%define debug_package %{nil} 

%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

Summary:	dff - open source digital investigation framework

Packager:	Lawrence R. Rogers (lrr@cert.org)

Vendor:		cert.org
Name:		dff
Version:	1.2.0
Release:	3%{?dist}

License:	GPL

Group:		Applications/Forensics Tools
Source:		%{name}-src-%{version}.tar.gz

BuildRoot:	%{_tmppath}/rpm-root-%{name}-v%{version}
BuildRequires:	gcc-c++ libstdc++-devel
%if 0%{?fedora} >= 13
BuildRequires:	file-static
%endif
%if 0%{?fedora} == 12
BuildRequires:	file-devel
%endif
%if 0%{?fedora} > 0
BuildRequires:	python >= 2.5
%endif
%if 0%{?rhel} > 0
BuildRequires:	%{__python}
%endif
BuildRequires:	python-devel
%if 0%{?fedora} > 0
BuildRequires:	swig >= 1.3.38
%endif
%if 0%{?rhel} == 6
BuildRequires:	swig >= 1.3.38
%endif
%if 0%{?rhel} == 5
BuildRequires:	swig >= 1.3.29
%endif
BuildRequires:	cmake
%if 0%{?fedora} > 0
BuildRequires:  PyQt4-devel
%endif
%if 0%{?rhel} >= 6
BuildRequires:  PyQt4-devel
%endif
%if 0%{?rhel} == 5
BuildRequires:  PyQt-devel
%endif
%if 0%{?rhel} != 5
BuildRequires:	python-magic
%endif
BuildRequires:	libewf-devel >= 20110903
BuildRequires:	afflib-devel
BuildRequires:	libpff
BuildRequires:	libbfio-devel
%if 0%{?fedora} > 0
Requires:	python >= 2.5
%endif
%if 0%{?rhel} > 0
Requires:	%{__python}
%endif
%if 0%{?rhel} != 5
Requires:	python-magic
%endif
Requires:	libewf
Requires:	libpff
Requires:	afflib
Requires:	libbfio
Requires:	python-apsw

%description
The Digital Forensics Framework (DFF) is both a digital investigation
tool and a development platform. The framework is used by system
administrators, law enforcement examinors, digital forensics researchers
and students, and security professionals world-wide. Written in Python
and C++, it exclusively uses Open Source technologies.
DFF combines an intuitive user interface with a modular and cross-platform
architecture.

%prep
%setup 

%build
mkdir dff-build && cd dff-build
cmake -DINSTALL=YES -DCMAKE_SKIP_RPATH=ON -DCMAKE_INSTALL_PREFIX=%{_prefix} ..
make -j2

%install
cd dff-build
%{__make} DESTDIR=%{buildroot} install

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(644, root, root, 755)
%doc CHANGES CHANGES.current RELEASENOTES
%attr(555, root, root)		%{_bindir}/%{name}
%attr(444, root, root)		%{_mandir}/man1/%{name}.1.gz
%attr(444, root, root)		%{_datadir}/pixmaps/*
%attr(444, root, root)		%{_datadir}/applications/%{name}.desktop
%attr(0644, root, root)		%{python_sitelib}/%{name}/*.py*
%attr(0644, root, root)		%{python_sitelib}/%{name}/*/*.py*
%attr(0644, root, root)		%{python_sitelib}/%{name}/*/*/*.py*
%attr(0644, root, root)		%{python_sitelib}/%{name}/*/*/*/*.py*
%attr(0644, root, root)		%{python_sitelib}/%{name}/*/*/*/*/*.py*
%attr(0644, root, root)		%{python_sitelib}/%{name}/*/*/*/*/*/*.py*
%attr(0644, root, root)		%{python_sitelib}/%{name}/ui/gui/help.*
%attr(0644, root, root)		%{python_sitelib}/%{name}/ui/gui/i18*/*.qm
%attr(0755, root, root)		%{python_sitelib}/%{name}/*/*/*.so
%attr(0755, root, root)		%{python_sitelib}/%{name}/*/*/*/*.so

%changelog
* Tue Jan 7 2012 Lawrence R. Rogers <lrr@cert.org> 1.2.0-3
* Release 1.2.0-3
	Added support for EWF formatted files.

* Thu Oct 13 2011 Lawrence R. Rogers <lrr@cert.org> 1.2.0-2
* Release 1.2.0-2
	Added python-apsw dependency

* Wed Oct 5 2011 Lawrence R. Rogers <lrr@cert.org> 1.2.0-1
* Release 1.2.0-1
	See the included RELEASENOTES for the complete list of changes

* Fri May 20 2011 Lawrence R. Rogers <lrr@cert.org> 1.1.0-1
* Release 1.1.0-1
	
	Features: 
	---------
	
	* Translation : DFF GUI is now available in chinese, thanks to Zhang Jun.
			Other languages were updated : Deutch, Italian, ...
	
	* AFF : A connector to support AFF dump. The module is based on AFFLib by Simson
	L. Garfinkel (http://afflib.org)
	
	* PFF : This module parses PST, OST and PAB files to extract mailbox contents, it
	also recovers deleted and orphaned files and give access to unallocated clusters.
	It's based on Joachim Metz LibPFF. (http://sourceforge.net/projects/libpff)
	
	
	* API : New cache system for FileMapping and File Descriptor.
		vtime now can directly convert unix and windows 64 bits time stamp.
	
	* FAT:
	  - extended attributes:
	      * When there is slack space, a dedicated attribute specifies its start 
	     	offset and its size. 
	     	This feature is only available for classical files (neither deleted nor
		orphaned)
	      * Classical attributes are provided: Read Only, Hidden, System, Archive,
	     	Volume
	      * DOS name is provided (8+3 name)
	  - Orphaned files scan
	        The algorithm is now faster. When walking on free clusters, checks are
	     	done to know if it was previously parsed when walking on deleted files
		and directories in allocated clusters. Since chain of clusters of deleted
		directories are used, this pass could read and parse free clusters.
	
	* GUI: Unicode support
	
	
	Bug fixes:
	----------
	
	* Add devices and Add files on Windows, it was not possible to add devices and
	files or directories in the same session.
	
	* MFSO opened only one file descriptor and cache it, leading to crash especially
	 using device module on windows platform, a totally new cache system was written
	for FileMapping and File Descriptor.
	
	* EWF : Sometimes the modules could not open the underlaying due to bad fd
	handling this was fixed by using variant.
	
	* FAT :
	  -  Recovery of deleted files was not properly handled. Previous version relied
	     on the chain of clusters found in FAT which are often emptied when files are
	     deleted. Now, the module gets the first cluster, asks the FAT for a the 
	     chain of cluster, if the size of all provided is smaller than the size of 
	     file, the mapping starts from the first cluster until size of the file is 
	     reached.
	  -  Even if not noticeable by users (hashes of files were coherent for example)
	     and not really a bug, the previous mapping for files were cluster aligned.
	     It means the slack space of files were directly included in the mapping.
	     This was done this way in prediction of future implementation of MFSO. 
	     This feature would be able to read either original size or slack space.
	     Since it is not implemented yet, the mapping is now fully based on the size
	     of the file. This patch has been developed based on Johannes Stuttgen's
	     feedback when he was working on the aff4 module.
	
	* NTFS :
	  -  Fix for files-end made of virtual chunks ; full of 0.
	  -  Infinite loop fix when searching for parent of deleted or orphan items.
	  -  Two segfault fixes on metadata parsing due to complex on-disk structure
	     of NTFS attributes.
	
	* GUI :
	  -  A bug occuring when trying to input a Node as a parameter to modules has
	     been fixed : it was not possible to browse in the tree view.
	  -  The tree view, in the node browser, had an inconsitant behavior : to change
	     directories, users had to double-click on nodes names, which used to
	     collapse the tree view. This is fixed. The node browser now behaves as a
	     classic file browser.
	
	* Variant vtime repr:
	  -  Dealing with vtime encapsulated in Variant in the Python interpreter, an
	     exception were raised because there were no __repr__ or __str__ provided
	     for this type.
